package PiTube::Controller::OAuth2;
use Mojo::Base 'Mojolicious::Controller';
use YAML;

sub callback {
    my $c = shift;

    my $token = $c->oauth2->get_access_token($c->param("code"));

    # TODO: ERROR HANDLING

    my $claims  = $c->oauth_claims( $token->access_token );

    $c->session->{refresh_token} = $token->refresh_token;

    $c->session->{user} = {
        uuid     => $claims->{sub},
        name     => $claims->{name},
        username => $claims->{preferred_username},
    };

    my $user = $c->schema->resultset('User')->update_or_create(
        $c->session->{user},
        { key => 'uuid', }
    );
    $user->set_token();

    $c->session->{user}{id}     = $user->id;
    $c->session->{user}{token}  = $user->token;
    $c->session->{user}{roles}  = $c->oauth_roles($claims);
    $c->session->{user}{groups} = $c->oauth_groups($claims);
    $c->session->{user}{acl}    = $c->schema->resultset('ACL')->user_acl(
        $c->session->{user}
    );

    $c->authenticate();
    $c->redirect_to('/');
}

sub do_logout { # nesmi se jmenovat logout - rekurze
    my $c = shift;

    $c->logout;
    delete $c->session->{user};
    $c->redirect_to('/');
}

1;
