package PiTube::Schema::Result::ACL;

use strict;
use warnings;

use base 'DBIx::Class::Core';

our $VERSION = 1;

__PACKAGE__->table('acl');

__PACKAGE__->add_columns(
    id => {
        data_type         => 'integer',
        is_auto_increment => 1,
        is_nullable       => 0,
        sequence          => 'uid_seq'
    },
    qw(
        stream_id
        rights
        class
        value
    ),
);

__PACKAGE__->set_primary_key('id');

__PACKAGE__->belongs_to(
    stream => 'PiTube::Schema::Result::Stream',
    {
        'foreign.id' => 'self.stream_id',
    },
);

1;
