package PiTube::Schema::Result::Stream;

use strict;
use warnings;

use base 'DBIx::Class::Core';

our $VERSION = 1;

__PACKAGE__->table('streams');

__PACKAGE__->add_columns(
    id => {
        data_type         => 'integer',
        is_auto_increment => 1,
        is_nullable       => 0,
        sequence          => 'uid_seq'
    },
    qw(
        is_active
        is_public
        is_live
        key
        name
        description
        recording
        publish_last
        publish_user_id
        publish_time
    ),
);

__PACKAGE__->set_primary_key('id');

__PACKAGE__->add_unique_constraint(
    'key' => [qw(key)]
);

__PACKAGE__->has_many(
    acls => 'PiTube::Schema::Result::ACL',
    {
        'foreign.stream_id' => 'self.id',
    },
);

__PACKAGE__->has_many(
    records => 'PiTube::Schema::Result::Record',
    {
        'foreign.stream_id' => 'self.id',
    },
);

1;
